#! /usr/bin/env python

# testmallows.py
# 
# Description: A demonstration of fitting a mallows model from simulated rankings
#
# Author: Jonathan Huang

import mallows as ma
import permFuncs as pf
from math import exp

# instanstiate a generalized mallows model data structure and simulate from model
sigma0 = [3,2,0,1]
phi = [exp(-.8), exp(-.5), exp(-.7)]

n = len(sigma0)
P = ma.mallows.createMallows(phi,sigma0)
# print(P) 

print('Drawing from model')
sigmas = P.draw(5000)
D = pf.makeDict(sigmas)

# fit parameters
(pi0,phifit) = ma.mallows.fitMallows(n,D)

print('Model parameters: ')
print('sigma0: ' + str(sigma0))
print('phi: ' + str(phi))
print('\nFit parameters')
print('estimated sigma0: ' + str(pi0))
print('estimated phi: ' + str(phifit))









